import { jsx as l, jsxs as f, Fragment as L } from "react/jsx-runtime";
import i from "clsx";
import T, { useState as U, useEffect as O } from "react";
/*!
  @versini/ui-bubble v3.1.9
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "3.1.9",
    buildTime: "01/19/2025 01:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const j = "av-bubble", E = "av-button", y = "icon", S = "button", C = "link", H = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: s
}) => {
  const o = "max-h-8 py-0 px-2", n = "max-h-9 h-8 px-3", d = "max-h-12 py-2 px-4";
  switch (e) {
    case S:
    case C:
      return i({
        [o]: r === "small",
        [n]: r === "medium",
        [d]: r === "large"
      });
    case y:
      return i("inline-flex items-center", {
        "justify-center": s === "center",
        "justify-start": s === "left",
        "justify-end": s === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-2": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-3": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4": r === "large" && (t || a)
      });
  }
}, P = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a
}) => {
  const s = "text-sm font-medium", o = "text-base font-medium", n = "text-lg font-medium";
  switch (e) {
    case S:
    case C:
      return i({
        "text-center": e === C,
        [s]: r === "small",
        [o]: r === "medium",
        [n]: r === "large"
      });
    case y:
      return i({
        [s]: r === "small" && (t || a),
        [o]: r === "medium" && (t || a),
        [n]: r === "large" && (t || a)
      });
  }
}, W = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose";
  if (a === "primary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "light" || e === "system",
      "text-copy-lighter": e === "dark" || e === "alt-system",
      "dark:text-copy-lighter": e === "alt-system",
      "dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "selected")
    return i("not-prose text-copy-lighter", {
      truncate: !t
    });
}, A = ({
  mode: e,
  noBackground: r,
  variant: t
}) => {
  if (!r) {
    if (t === "primary")
      return i({
        "bg-action-dark": e === "dark",
        "bg-action-light": e === "light",
        "bg-action-dark dark:bg-action-light": e === "system",
        "bg-action-light dark:bg-action-dark": e === "alt-system"
      });
    if (t === "secondary")
      return i({
        "bg-action-dark": e === "light",
        "bg-action-light": e === "dark",
        "bg-action-dark dark:bg-action-light": e === "alt-system",
        "bg-action-light dark:bg-action-dark": e === "system"
      });
    if (t === "danger")
      return i({
        "bg-action-danger-dark": e === "dark",
        "bg-action-danger-light": e === "light",
        "bg-action-danger-dark dark:bg-action-danger-light": e === "system",
        "bg-action-danger-light dark:bg-action-danger-dark": e === "alt-system"
      });
    if (t === "selected")
      return "bg-action-selected-dark";
  }
}, G = ({
  radius: e
}) => i({
  "rounded-full": e === "large",
  "rounded-md": e === "medium",
  "rounded-sm": e === "small"
}), q = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (t === "selected")
    return "hover:text-copy-light-hover hover:bg-action-selected-dark-hover";
}, Y = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (t === "selected")
    return "active:text-copy-lighter-active active:bg-action-selected-dark-active";
}, $ = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (t === "selected")
    return "border border-border-selected-dark";
}, D = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), F = ({
  mode: e,
  raw: r,
  iconClassName: t
}) => r ? "" : i(
  {
    "text-copy-accent-dark": e === "light" || e === "alt-system",
    "text-copy-light": e === "dark" || e === "system",
    "dark:text-copy-light": e === "alt-system",
    "dark:text-copy-accent-dark": e === "system"
  },
  t
), R = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: s,
  disabled: o,
  fullWidth: n,
  size: d,
  noBorder: u,
  labelRight: g,
  labelLeft: v,
  noBackground: h,
  variant: c,
  noTruncate: b,
  align: m,
  radius: p
}) => (c || (c = "primary"), t ? i(E, r) : i(
  E,
  W({
    mode: a,
    variant: c,
    noBackground: h,
    noTruncate: b
  }),
  A({ mode: a, noBackground: h, variant: c }),
  G({ radius: p }),
  H({
    type: e,
    size: d,
    labelRight: g,
    labelLeft: v,
    align: m
  }),
  P({ type: e, size: d, labelRight: g, labelLeft: v }),
  $({ mode: a, variant: c, noBorder: u }),
  D({ focusMode: s }),
  q({ mode: a, variant: c, disabled: o }),
  Y({ mode: a, variant: c, disabled: o }),
  {
    "w-full": n,
    "disabled:cursor-not-allowed disabled:opacity-50": o
  },
  r
)), J = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, z = T.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...s } = e;
  return /* @__PURE__ */ l(
    "button",
    {
      ref: r,
      onClick: (o) => {
        J(o, a, t);
      },
      ...s
    }
  );
});
z.displayName = "BaseButton";
const M = T.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: s = !1,
    className: o,
    type: n = "button",
    raw: d = !1,
    noBorder: u = !1,
    "aria-label": g,
    label: v,
    size: h = "medium",
    labelRight: c,
    labelLeft: b,
    noBackground: m = !1,
    align: p = "center",
    radius: k = "large",
    variant: x = "primary",
    iconClassName: w,
    ...B
  }, _) => {
    const N = R({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: s,
      disabled: r,
      raw: d,
      className: o,
      noBorder: u,
      size: h,
      labelRight: c,
      labelLeft: b,
      noBackground: m,
      align: p,
      radius: k,
      variant: x
    }), I = F({ mode: t, raw: d, iconClassName: w });
    return /* @__PURE__ */ f(
      z,
      {
        ref: _,
        className: N,
        disabled: r,
        type: n,
        "aria-label": g || v,
        ...B,
        children: [
          b && /* @__PURE__ */ l("span", { className: "pr-2", children: b }),
          /* @__PURE__ */ l("div", { className: I, children: e }),
          c && /* @__PURE__ */ l("span", { className: "pl-2", children: c })
        ]
      }
    );
  }
);
M.displayName = "ButtonIcon";
/*!
  @versini/ui-button v4.1.1
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "4.1.1",
    buildTime: "01/19/2025 01:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = T.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: s = !1,
    className: o,
    type: n = "button",
    raw: d = !1,
    noBorder: u = !1,
    "aria-label": g,
    label: v,
    size: h = "medium",
    labelRight: c,
    labelLeft: b,
    noBackground: m = !1,
    align: p = "center",
    active: k = !1,
    radius: x = "large",
    ...w
  }, B) => {
    const _ = R({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: s,
      disabled: r,
      raw: d,
      className: o,
      noBorder: u,
      size: h,
      labelRight: c,
      labelLeft: b,
      noBackground: m,
      align: p,
      radius: x
    }), N = i({
      "text-copy-accent-dark": t === "light" && !d,
      "text-copy-light": t === "dark" && !d,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !d,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !d
    }), I = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ l("div", { className: I, children: /* @__PURE__ */ f(
      z,
      {
        ref: B,
        className: _,
        disabled: r,
        type: n,
        "aria-label": g || v,
        ...w,
        children: [
          b && /* @__PURE__ */ l("span", { className: "pr-2", children: b }),
          /* @__PURE__ */ l("div", { className: N, children: e }),
          c && /* @__PURE__ */ l("span", { className: "pl-2", children: c })
        ]
      }
    ) });
  }
);
K.displayName = "ButtonSort";
const V = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: s,
  size: o,
  title: n,
  semantic: d = !1,
  ...u
}) => {
  const g = i(o, a);
  return /* @__PURE__ */ f(L, { children: [
    /* @__PURE__ */ l(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: g,
        viewBox: t || s,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !d,
        focusable: !1,
        ...u,
        children: e
      }
    ),
    n && d && /* @__PURE__ */ l("span", { className: "sr-only", children: n })
  ] });
};
/*!
  @versini/ui-svgicon v4.0.5
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "4.0.5",
    buildTime: "01/19/2025 01:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...s
}) => /* @__PURE__ */ f(
  V,
  {
    defaultViewBox: "0 0 448 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copied",
    ...s,
    children: [
      /* @__PURE__ */ l(
        "path",
        {
          d: "M0 96v320c0 35.3 28.7 64 64 64h320c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64C28.7 32 0 60.7 0 96m104 160c0-6.1 2.3-12.3 7-17 9.4-9.4 24.6-9.4 33.9 0l47 47 111-111c4.7-4.7 10.8-7 17-7s12.3 2.3 17 7c2.3 2.3 4.1 5 5.3 7.9.6 1.5 1 2.9 1.3 4.4.2 1.1.3 2.2.3 2.2.1 1.2.1 1.2.1 2.5-.1 1.5-.1 1.9-.1 2.3-.1.7-.2 1.5-.3 2.2-.3 1.5-.7 3-1.3 4.4-1.2 2.9-2.9 5.6-5.3 7.9l-128 128c-4.7 4.7-10.8 7-17 7s-12.3-2.3-17-7l-64-64c-4.7-4.7-7-10.8-7-17z",
          opacity: ".4"
        }
      ),
      /* @__PURE__ */ l("path", { d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z" })
    ]
  }
), X = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...s
}) => /* @__PURE__ */ l(
  V,
  {
    defaultViewBox: "0 0 512 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copy",
    ...s,
    children: /* @__PURE__ */ l("path", { d: "M64 464h224c8.8 0 16-7.2 16-16v-64h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16v224c0 8.8 7.2 16 16 16m160-160h224c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16v224c0 8.8 7.2 16 16 16m-64-16V64c0-35.3 28.7-64 64-64h224c35.3 0 64 28.7 64 64v224c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64" })
  }
);
/*!
  @versini/ui-icons v4.5.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "4.5.0",
    buildTime: "01/19/2025 01:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Z = ({
  kind: e,
  noMaxWidth: r
}) => i("p-4", {
  "max-w-xs sm:max-w-md md:max-w-2xl": !r,
  "lg:max-w-3xl": e === "left" && !r
}), ee = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), te = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), re = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), ae = ({
  kind: e,
  className: r,
  noMaxWidth: t
}) => {
  const a = i(
    j,
    "flex items-start",
    {
      "flex-row-reverse": e === "right"
    },
    r
  ), s = i(
    "flex flex-col empty:hidden",
    Z({ kind: e, noMaxWidth: t }),
    te({ kind: e }),
    ee({ kind: e }),
    re({ kind: e })
  ), o = "pr-2 pt-1 text-end text-xs text-copy-light", n = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: a,
    main: s,
    footer: o,
    copyButton: n
  };
}, le = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: a,
  rawFooter: s,
  copyToClipboard: o,
  copyToClipboardFocusMode: n = "system",
  copyToClipboardMode: d = "system",
  noMaxWidth: u = !1
}) => {
  const [g, v] = U(!1), h = ae({ kind: r, className: t, noMaxWidth: u }), c = !!o && (typeof o == "function" || typeof o == "string" || typeof e == "string"), b = () => {
    v(!0), typeof o == "function" ? o(e) : typeof o == "string" ? navigator.clipboard.writeText(o) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return O(() => {
    let m;
    return g && (m = window.setTimeout(() => {
      v(!1);
    }, 3e3)), () => {
      clearTimeout(m);
    };
  }, [g]), /* @__PURE__ */ f("div", { className: h.wrapper, children: [
    /* @__PURE__ */ f("div", { children: [
      /* @__PURE__ */ l("div", { className: h.main, children: e }),
      a && Object.keys(a).map((m) => a[m] ? /* @__PURE__ */ l("div", { className: "prose-p:m-0", children: /* @__PURE__ */ f("p", { className: h.footer, children: [
        m,
        ": ",
        a[m]
      ] }) }, `-${m}`) : null),
      s && s
    ] }),
    c && /* @__PURE__ */ l("div", { className: h.copyButton, children: /* @__PURE__ */ l(
      M,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: d,
        focusMode: n,
        label: g ? "Copied to clipboard" : "Copy to clipboard",
        onClick: b,
        disabled: g,
        children: g ? /* @__PURE__ */ l(Q, { size: "size-3" }) : /* @__PURE__ */ l(X, { size: "size-3" })
      }
    ) })
  ] });
};
export {
  j as BUBBLE_CLASSNAME,
  le as Bubble
};
